///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"
#import "DBTEAMMemberAddArgBase.h"

@class DBTEAMMemberAddV2Arg;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `MemberAddV2Arg` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMMemberAddV2Arg : DBTEAMMemberAddArgBase <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// (no description).
@property (nonatomic, readonly, nullable) NSArray<NSString *> *roleIds;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param memberEmail (no description).
/// @param memberGivenName Member's first name.
/// @param memberSurname Member's last name.
/// @param memberExternalId External ID for member.
/// @param memberPersistentId Persistent ID for member. This field is only
/// available to teams using persistent ID SAML configuration.
/// @param sendWelcomeEmail Whether to send a welcome email to the member. If
/// send_welcome_email is false, no email invitation will be sent to the user.
/// This may be useful for apps using single sign-on (SSO) flows for onboarding
/// that want to handle announcements themselves.
/// @param isDirectoryRestricted Whether a user is directory restricted.
/// @param roleIds (no description).
///
/// @return An initialized instance.
///
- (instancetype)initWithMemberEmail:(NSString *)memberEmail
                    memberGivenName:(nullable NSString *)memberGivenName
                      memberSurname:(nullable NSString *)memberSurname
                   memberExternalId:(nullable NSString *)memberExternalId
                 memberPersistentId:(nullable NSString *)memberPersistentId
                   sendWelcomeEmail:(nullable NSNumber *)sendWelcomeEmail
              isDirectoryRestricted:(nullable NSNumber *)isDirectoryRestricted
                            roleIds:(nullable NSArray<NSString *> *)roleIds;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
/// @param memberEmail (no description).
///
/// @return An initialized instance.
///
- (instancetype)initWithMemberEmail:(NSString *)memberEmail;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `MemberAddV2Arg` struct.
///
@interface DBTEAMMemberAddV2ArgSerializer : NSObject

///
/// Serializes `DBTEAMMemberAddV2Arg` instances.
///
/// @param instance An instance of the `DBTEAMMemberAddV2Arg` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMMemberAddV2Arg` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMMemberAddV2Arg *)instance;

///
/// Deserializes `DBTEAMMemberAddV2Arg` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMMemberAddV2Arg` API object.
///
/// @return An instantiation of the `DBTEAMMemberAddV2Arg` object.
///
+ (DBTEAMMemberAddV2Arg *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
