///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGAdminAlertGeneralStateEnum;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `AdminAlertGeneralStateEnum` union.
///
/// Alert state
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGAdminAlertGeneralStateEnum : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMLOGAdminAlertGeneralStateEnumTag` enum type represents the
/// possible tag states with which the `DBTEAMLOGAdminAlertGeneralStateEnum`
/// union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBTEAMLOGAdminAlertGeneralStateEnumTag){
    /// (no description).
    DBTEAMLOGAdminAlertGeneralStateEnumActive,

    /// (no description).
    DBTEAMLOGAdminAlertGeneralStateEnumDismissed,

    /// (no description).
    DBTEAMLOGAdminAlertGeneralStateEnumInProgress,

    /// (no description).
    DBTEAMLOGAdminAlertGeneralStateEnumNa,

    /// (no description).
    DBTEAMLOGAdminAlertGeneralStateEnumResolved,

    /// (no description).
    DBTEAMLOGAdminAlertGeneralStateEnumOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMLOGAdminAlertGeneralStateEnumTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "active".
///
/// @return An initialized instance.
///
- (instancetype)initWithActive;

///
/// Initializes union class with tag state of "dismissed".
///
/// @return An initialized instance.
///
- (instancetype)initWithDismissed;

///
/// Initializes union class with tag state of "in_progress".
///
/// @return An initialized instance.
///
- (instancetype)initWithInProgress;

///
/// Initializes union class with tag state of "na".
///
/// @return An initialized instance.
///
- (instancetype)initWithNa;

///
/// Initializes union class with tag state of "resolved".
///
/// @return An initialized instance.
///
- (instancetype)initWithResolved;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "active".
///
/// @return Whether the union's current tag state has value "active".
///
- (BOOL)isActive;

///
/// Retrieves whether the union's current tag state has value "dismissed".
///
/// @return Whether the union's current tag state has value "dismissed".
///
- (BOOL)isDismissed;

///
/// Retrieves whether the union's current tag state has value "in_progress".
///
/// @return Whether the union's current tag state has value "in_progress".
///
- (BOOL)isInProgress;

///
/// Retrieves whether the union's current tag state has value "na".
///
/// @return Whether the union's current tag state has value "na".
///
- (BOOL)isNa;

///
/// Retrieves whether the union's current tag state has value "resolved".
///
/// @return Whether the union's current tag state has value "resolved".
///
- (BOOL)isResolved;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBTEAMLOGAdminAlertGeneralStateEnum` union.
///
@interface DBTEAMLOGAdminAlertGeneralStateEnumSerializer : NSObject

///
/// Serializes `DBTEAMLOGAdminAlertGeneralStateEnum` instances.
///
/// @param instance An instance of the `DBTEAMLOGAdminAlertGeneralStateEnum` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGAdminAlertGeneralStateEnum` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGAdminAlertGeneralStateEnum *)instance;

///
/// Deserializes `DBTEAMLOGAdminAlertGeneralStateEnum` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGAdminAlertGeneralStateEnum` API object.
///
/// @return An instantiation of the `DBTEAMLOGAdminAlertGeneralStateEnum`
/// object.
///
+ (DBTEAMLOGAdminAlertGeneralStateEnum *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
