///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"
#import "DBTEAMLOGAppLogInfo.h"

@class DBTEAMLOGUserLinkedAppLogInfo;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `UserLinkedAppLogInfo` struct.
///
/// User linked app
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGUserLinkedAppLogInfo : DBTEAMLOGAppLogInfo <DBSerializable, NSCopying>

#pragma mark - Instance fields

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param appId App unique ID.
/// @param displayName App display name.
///
/// @return An initialized instance.
///
- (instancetype)initWithAppId:(nullable NSString *)appId displayName:(nullable NSString *)displayName;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
///
/// @return An initialized instance.
///
- (instancetype)initDefault;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `UserLinkedAppLogInfo` struct.
///
@interface DBTEAMLOGUserLinkedAppLogInfoSerializer : NSObject

///
/// Serializes `DBTEAMLOGUserLinkedAppLogInfo` instances.
///
/// @param instance An instance of the `DBTEAMLOGUserLinkedAppLogInfo` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGUserLinkedAppLogInfo` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGUserLinkedAppLogInfo *)instance;

///
/// Deserializes `DBTEAMLOGUserLinkedAppLogInfo` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGUserLinkedAppLogInfo` API object.
///
/// @return An instantiation of the `DBTEAMLOGUserLinkedAppLogInfo` object.
///
+ (DBTEAMLOGUserLinkedAppLogInfo *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
