///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMPOLICIESExternalDriveBackupPolicyState;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `ExternalDriveBackupPolicyState` union.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMPOLICIESExternalDriveBackupPolicyState : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMPOLICIESExternalDriveBackupPolicyStateTag` enum type represents
/// the possible tag states with which the
/// `DBTEAMPOLICIESExternalDriveBackupPolicyState` union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBTEAMPOLICIESExternalDriveBackupPolicyStateTag){
    /// External Drive Backup feature is disabled.
    DBTEAMPOLICIESExternalDriveBackupPolicyStateDisabled,

    /// External Drive Backup feature is enabled.
    DBTEAMPOLICIESExternalDriveBackupPolicyStateEnabled,

    /// External Drive Backup default value based on team tier.
    DBTEAMPOLICIESExternalDriveBackupPolicyStateDefault_,

    /// (no description).
    DBTEAMPOLICIESExternalDriveBackupPolicyStateOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMPOLICIESExternalDriveBackupPolicyStateTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "disabled".
///
/// Description of the "disabled" tag state: External Drive Backup feature is
/// disabled.
///
/// @return An initialized instance.
///
- (instancetype)initWithDisabled;

///
/// Initializes union class with tag state of "enabled".
///
/// Description of the "enabled" tag state: External Drive Backup feature is
/// enabled.
///
/// @return An initialized instance.
///
- (instancetype)initWithEnabled;

///
/// Initializes union class with tag state of "default".
///
/// Description of the "default" tag state: External Drive Backup default value
/// based on team tier.
///
/// @return An initialized instance.
///
- (instancetype)initWithDefault_;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "disabled".
///
/// @return Whether the union's current tag state has value "disabled".
///
- (BOOL)isDisabled;

///
/// Retrieves whether the union's current tag state has value "enabled".
///
/// @return Whether the union's current tag state has value "enabled".
///
- (BOOL)isEnabled;

///
/// Retrieves whether the union's current tag state has value "default".
///
/// @return Whether the union's current tag state has value "default".
///
- (BOOL)isDefault_;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the
/// `DBTEAMPOLICIESExternalDriveBackupPolicyState` union.
///
@interface DBTEAMPOLICIESExternalDriveBackupPolicyStateSerializer : NSObject

///
/// Serializes `DBTEAMPOLICIESExternalDriveBackupPolicyState` instances.
///
/// @param instance An instance of the
/// `DBTEAMPOLICIESExternalDriveBackupPolicyState` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMPOLICIESExternalDriveBackupPolicyState` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMPOLICIESExternalDriveBackupPolicyState *)instance;

///
/// Deserializes `DBTEAMPOLICIESExternalDriveBackupPolicyState` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMPOLICIESExternalDriveBackupPolicyState` API object.
///
/// @return An instantiation of the
/// `DBTEAMPOLICIESExternalDriveBackupPolicyState` object.
///
+ (DBTEAMPOLICIESExternalDriveBackupPolicyState *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
